"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../src/index");
const assert_1 = require("assert");
class Book extends index_1.JSONObject {
}
__decorate([
    index_1.JSONObject.required,
    __metadata("design:type", String)
], Book.prototype, "name", void 0);
__decorate([
    index_1.JSONObject.optional,
    __metadata("design:type", String)
], Book.prototype, "summary", void 0);
// This is ok
let book = new Book({ name: "Moby Dick", summary: "You're my obsession" });
// This is also ok
let b2 = new Book({ name: "Moby Dick" }); // Also ok
// Summary is undefined
assert_1.strict(b2.summary === undefined);
// This will throw a TypeError, as 'name' is required
assert_1.strict.throws(() => {
    let book = new Book({ summary: "Once upon a time" });
});
assert_1.strict.throws(() => {
    let book = new Book({ name: 12345 });
});
//Subobjects are supported
class Author extends index_1.JSONObject {
}
__decorate([
    index_1.JSONObject.required,
    __metadata("design:type", String)
], Author.prototype, "name", void 0);
class BookWithAuthor extends index_1.JSONObject {
}
__decorate([
    index_1.JSONObject.required,
    __metadata("design:type", String)
], BookWithAuthor.prototype, "name", void 0);
__decorate([
    index_1.JSONObject.optional,
    __metadata("design:type", String)
], BookWithAuthor.prototype, "summary", void 0);
__decorate([
    index_1.JSONObject.required,
    __metadata("design:type", Author)
], BookWithAuthor.prototype, "author", void 0);
let book2 = new BookWithAuthor({ name: "Moby Dick", author: { name: "Herman Melville" } });
assert_1.strict.ok(book2.author instanceof Author);
//# sourceMappingURL=index.js.map